﻿using Microsoft.AspNetCore.Http;
using System.Threading.Tasks;

namespace TestProject
{
    /// <summary>
    /// 요청 가공 미들웨어
    /// </summary>
    public class RequestProcessingMiddleware
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 다음 미들웨어
        /// </summary>
        private RequestDelegate next;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - RequestProcessingMiddleware(next)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="next">다음 미들웨어</param>
        public RequestProcessingMiddleware(RequestDelegate next)
        {
            this.next = next;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 호출하기 - Invoke(context)

        /// <summary>
        /// 호출하기
        /// </summary>
        /// <param name="context">HTTP 컨텍스트</param>
        /// <returns>태스크</returns>
        public async Task Invoke(HttpContext context)
        {
            if(context.Request.Path.ToString().ToLower() == "/secret")
            {
                context.Request.Path = new PathString("/");
            }

            await next.Invoke(context);
        }

        #endregion
    }
}